select dynemp.ename
      ,dynemp.job
      ,dynemp.sal
      ,dynemp.rank
   from (select ename
               ,sal
               ,job
               ,dense_rank() over (partition by job order by sal desc) rank
  	 from emp) dynemp
  where dynemp.rank < 3
  order by dynemp.job
          ,dynemp.rank      
/
